#ifndef NULLOSFT_MEDIALIBRARY_MS_DWM_HEADER
#define NULLOSFT_MEDIALIBRARY_MS_DWM_HEADER

#if defined(_MSC_VER) && (_MSC_VER >= 1020)
#pragma once
#endif

#include <windows.h>

#ifndef WM_DWMCOMPOSITIONCHANGED
#define WM_DWMCOMPOSITIONCHANGED		0x031E
#define WM_DWMNCRENDERINGCHANGED		0x031F
#define WM_DWMCOLORIZATIONCOLORCHANGED	0x0320
#define WM_DWMWINDOWMAXIMIZEDCHANGE		0x0321
#endif

typedef enum _DWMWINDOWATTRIBUTE {
    DWMWA_NCRENDERING_ENABLED = 1,
    DWMWA_NCRENDERING_POLICY,
    DWMWA_TRANSITIONS_FORCEDISABLED,
    DWMWA_ALLOW_NCPAINT,
    DWMWA_CAPTION_BUTTON_BOUNDS,
    DWMWA_NONCLIENT_RTL_LAYOUT,
    DWMWA_FORCE_ICONIC_REPRESENTATION,
    DWMWA_FLIP3D_POLICY,
    DWMWA_EXTENDED_FRAME_BOUNDS,
    DWMWA_LAST
} DWMWINDOWATTRIBUTE;

typedef enum _DWMNCRENDERINGPOLICY {
    DWMNCRP_USEWINDOWSTYLE,
    DWMNCRP_DISABLED,
    DWMNCRP_ENABLED,
    DWMNCRP_LAST
} DWMNCRENDERINGPOLICY;

#define E_MLDWM_NOTLOADED	MAKE_HRESULT(0, FACILITY_ITF, 0x0201) // library not loaded (you just need to call MlDwm_LoadLibrary)
#define E_MLDWM_LOADFAILED	MAKE_HRESULT(1, FACILITY_ITF, 0x0202) // library load failed (probably not vista?)
#define E_MLDWM_BADFUNCTION	MAKE_HRESULT(1, FACILITY_ITF, 0x0203) // function was not loaded

HRESULT MlDwm_LoadLibrary(void);
HRESULT MlDwm_GetLoadResult(void);
HRESULT MlDwm_SetWindowAttribute(HWND hwnd, DWORD dwAttribute, LPCVOID pvAttribute, DWORD cbAttribute);
HRESULT MlDwm_IsCompositionEnabled(BOOL *pfEnabled);


#endif // NULLOSFT_MEDIALIBRARY_MS_DWM_HEADER